<%
'----------------------------------------------------
function translateBoolean(theValue)
	if ucase(theValue)="Y" then
		translateBoolean = -1
	else
		translateBoolean = 0
	end if
end function
'----------------------------------------------------
function loadImageID(theValue)
	dim rsLoad
	dim sqlLoad
	
	set rsLoad = Server.CreateObject("ADODB.Recordset")
	sqlLoad = "select imageID from storeImages where storeID="&storeID&" and imageFileName='"&theValue&"'"
	rsLoad.open sqlLoad, storeConn, 1, 1
	if rsLoad.eof then
		loadImageID = 0
	else
		loadImageID = rsLoad("imageID")
	end if
	rsLoad.close
	set rsLoad = nothing
end function
'----------------------------------------------------
function loadCategID(theValue)
	dim rsLoad
	dim sqlLoad
	
	set rsLoad = Server.CreateObject("ADODB.Recordset")
	sqlLoad = "select categoryID from storeCategories where storeID="&storeID&" and categoryName='"&theValue&"'"
	rsLoad.open sqlLoad, storeConn, 1, 1
	if rsLoad.eof then
		loadCategID = 0
	else
		loadCategID = rsLoad("categoryID")
	end if
	rsLoad.close
	set rsLoad = nothing
end function
'----------------------------------------------------
function loadItemID(theValue)
	dim rsLoad
	dim sqlLoad
	
	set rsLoad = Server.CreateObject("ADODB.Recordset")
	'sqlLoad = "select productID from storeProducts where storeID="&storeID&" and productCode='"&theValue&"'"
	sqlLoad = "select productID from storeProducts where storeID="&storeID&" and productName='"&theValue&"'"
	rsLoad.open sqlLoad, storeConn, 1, 1
	if rsLoad.eof then
		loadItemID = 0
	else
		loadItemID = rsLoad("productID")
	end if
	rsLoad.close
	set rsLoad = nothing
end function
'----------------------------------------------------
function loadClassID(theValue)
	dim rsLoad
	dim sqlLoad
	
	set rsLoad = Server.CreateObject("ADODB.Recordset")
	sqlLoad = "select classID from storeProductsAtribClass where storeID="&storeID&" and className='"&theValue&"'"
	rsLoad.open sqlLoad, storeConn, 1, 1
	if rsLoad.eof then
		loadClassID = 0
	else
		loadClassID = rsLoad("classID")
	end if
	rsLoad.close
	set rsLoad = nothing
end function
'----------------------------------------------------
function clearField(aField)
	dim theRes
	if aField = "" then 
		clearField = ""
		exit function
	end if
	theRes = trim(aField)
	if theRes = "" then 
		clearField = ""
		exit function
	end if
	if fileDelimiter<>"" then
		if instr(theRes, fileDelimiter)=1 then theRes = mid (theRes, len(fileDelimiter)+1)
		if instrrev(theRes, fileDelimiter)=len(theRes)-len(fileDelimiter)+1 then theRes = mid (theRes, 1, len(theRes)-len(fileDelimiter))
	end if
	clearField = theRes
end function
'----------------------------------------------------
function getFieldType(aField)
	dim i
	for i=0 to ubound(fieldsDef)
		if ucase(aField)=ucase(fieldsDef(i,0)) then
			getFieldType = fieldsDef(i,1)
			exit function
		end if
	next
	getFieldType = ""
end function
'----------------------------------------------------
sub goToErrorPage(theError, theArg)
	dim errText
	
	errText = "We are sorry but there was an error with your request."
	select case ucase(theError)
		case "INVALID_FIELD"
			errText = errText & "There is an invalid field name into the header row (field # "&cint(theArg)+1&")."
		case "MISSING_REQ_FIELD"
			errText = errText & "Some required fields are missing (field: "&theArg&")."
		case "INVALID_NUMBER_OF_FIELDS_PER_LINE"
			errText = errText & "There is an invalid number of fields on line #"&theArg&"."
		case "INVALID_LINE_NUMBER_FIELD"
			errText = errText & "There is an invalid number value on line #"&theArg&"."
		case "INVALID_LINE_BOOL_FIELD"
			errText = errText & "There is an invalid boolean value on line #"&theArg&"."
		case "INVALID_LINE_DATE_FIELD"
			errText = errText & "There is an invalid date value on line #"&theArg&"."
	end select
	
	session("errMessage") = errText
	response.redirect "error.asp"
end sub
'----------------------------------------------------
%>