<!--#include file="../sessionManagement.asp"-->
<!--#include file="../subs/browseFunctions.asp"-->

<% 
'---------------------------------------------------------------------
	' browseFunctions.asp : calculateTotalPrice function
	' utilFunctions.asp   : getNumber
'---------------------------------------------------------------------

dim storeRS, storeRS2
dim productID, productName, productCode, productWeight, productMeasure, quantityInput
dim listAtributes, splitListAtributes, counter
dim quantityInStock, stepSaleFromPrice, theError
dim retailPrice, totalPrice, retailPriceInCart, totalPriceInCart, priceDescription

Set storeRS = Server.CreateObject("ADODB.Recordset")
select case trim(request("caller"))

	'--------------------------------------------------------------------------------------------
	case "browseProducts"
	
		productID = trim(request("productID"))
		if not testUrl(productID, errMessage) then
			session("errorMessage") = errMessage
			set storeRS = nothing
			set storeConn = nothing
			response.redirect "../error.asp?viewID=7"
		end if
		quantityInput = trim(request("quantity"))
		if not getNumber(quantityInput, quantityInput) then
			session("errorMessage") = Please_enter_a_valid_quantity_CONST
			set storeRS = nothing
			set storeConn = nothing
			response.redirect "../error.asp?"&urlString&"viewID=7"
		end if
		listAtributes = trim(request("listAtributes"))
		if listAtributes <> "" then
			splitListAtributes = split(listAtributes, ",")
			for counter = 0 to ubound(splitListAtributes)
				splitListAtributes(counter) = replace(splitListAtributes(counter), " ", "")
				if not testUrl(splitListAtributes(counter), errMessage) then
					session("errorMessage") = errMessage
					set storeRS = nothing
					set storeConn = nothing
					response.redirect "../error.asp?viewID=7"
				end if
			next
		end if
		quantityInStock = trim(request("quantityInStock"))
		if not getNumber(quantityInStock, quantityInStock) then
			set storeRS = nothing
			set storeConn = nothing
			session("errorMessage") = errMessage
			response.redirect "../error.asp?"&urlString&"viewID=7"
		end if
		quantityInStock = cdbl(quantityInStock)

		'test if exist a record in storeCustomersCart in order to update the quantity
		sqlString = "select quantity from storeCustomersCart where userID = '"&userID&"' and storeID = "&storeID&" and productID="&productID&" and listAtributes='"&listAtributes&"'"
		storeRS.open sqlString, storeConn, 1, 1
		if not storeRS.eof then
			quantityInput = quantityInput + cdbl(storeRS("quantity"))
		end if
		storeRS.close

		'test if the quantity is OK (if stepSale<>1 then the quantity is multiple of stepSale)
		setlocale("en-us")
		sqlString = "select priceLineID, price, stepSale, description from storeProductsPrices where storeID="&storeID&" and productID = "&productID&" and lowLimit<="&quantityInput&" and (highLimit>="&quantityInput&" or highLimit=0)"
		storeRS.open sqlString, storeConn, 1, 1
		setlocale(storeLocaleID)
		if storeRS.eof then
			session("errorMessage") = This_product_can_t_be_bought_CONST
			storeRS.close
			set storeRS = nothing
			set storeConn = nothing
			response.redirect "../error.asp?"&urlString&"viewID=7"
		else 
			stepSaleFromPrice = cdbl(storeRS("stepSale"))
			theError = quantityInput/stepSaleFromPrice
			if theError-clng(theError)<>0 then
				session("errorMessage") = The_product_can_be_sold_only_in_preestablished_quantities_CONST
				storeRS.close
				set storeRS = nothing
				set storeConn = nothing
				response.redirect "../error.asp?"&urlString&"viewID=7"
			end if
		end if
		
		'test if the quantity < quantity in stock !
		if quantityInStock <> -1 then
			if quantityInput > quantityInStock then
				session("errorMessage") = Product_out_of_stock_CONST
				set storeRS = nothing
				set storeConn = nothing
				response.redirect "../error.asp?"&urlString&"viewID=7"
			end if
		end if

		'----------- calculate the product price who will be saved in the shopping cart --------------------------

		retailPrice = cdbl(storeRS("price"))
		totalPrice = retailPrice
		call calculateTotalPrice(productID, retailPrice, totalPrice, storeRS("priceLineID"), listAtributes)
		retailPriceInCart = retailPrice*(quantityInput/stepSaleFromPrice)
		totalPriceInCart = totalPrice*(quantityInput/stepSaleFromPrice)
		priceDescription = storeRS("description")
		storeRS.close
		
		'------------- test the SKU of the product (if an attribute have SKU then SKU product = SKU attribute)-----
		productCode = ""
		if listAtributes <> "" then
			sqlString = "select code from storeProductsAtribValues where storeID = "&storeID&" and atribID in ("&listAtributes&") and productID = 0"
			storeRS.open sqlString, storeConn, 1, 1
			do while not storeRS.eof
				if storeRS("code") <> "" then
					productCode = storeRS("code")
					exit do
				end if
				storeRS.movenext
			loop
			storeRS.close
		end if
		
		'------------------------------------------------------------------------------------------------

		if listAtributes <> "" then
			sqlString = "select calculatePrice from storeProducts where storeID="&storeID&" and productID="&productID
			storeRS.open sqlString, storeConn, 1, 1
			if storeRS("calculatePrice") = false then 'the price will be calculate like a product price not a sum of atributes
				listAtributes = ""
			end if
			storeRS.close
		end if

		' ------------ Update the cart ---------------------
		setlocale("en-us")
		sqlString = "select productID, productName, productCode, weight, measure from storeProducts where storeID = "&storeID&" and productID = "&productID
		storeRS.open sqlString, storeConn, 1, 1
		productName = storeRS("productName")
		if productCode = "" then 'Insert SKU from product and not from attribute
			productCode = storeRS("productCode")
		end if
		if priceDescription <> "" then
			productName = productName&" ("&priceDescription&")"
		end if
		productWeight = cdbl(storeRS("weight"))
		productMeasure = storeRS("measure")
		if productWeight <> 0 then
			' test if exist weight difference on attributes
			if listAtributes <> "" then
				set storeRS2 = Server.CreateObject("ADODB.Recordset")
				sqlString = "select priceWeight from storeProductsAtribValues where storeID = "&storeID&" and atribID in ("&listAtributes&") and productID = 0"
				storeRS2.open sqlString, storeConn, 1, 1
				do while not storeRS2.eof
					if cdbl(storeRS2("priceWeight")) <> 0 then
						productWeight = productWeight + cdbl(storeRS2("priceWeight"))
					end if
					storeRS2.movenext
				loop
				storeRS2.close
				set storeRS2 = nothing
			end if
		end if
		
		'test if the record exist in the database
		sqlString = "select customerCartID, quantity from storeCustomersCart where userID = '"&userID&"' and storeID = "&storeID&" and productID = "&productID&" and listAtributes = '"&listAtributes&"'"
		dim storeTemp
		set storeTemp = Server.CreateObject("ADODB.Recordset")
		storeTemp.open sqlString, storeConn, 1, 1
		if storeTemp.eof then
			sqlString = "insert into storeCustomersCart (userID, storeID, productID, productName, productCode, productWeight, productMeasure, retailPriceInCart, totalPriceInCart, quantity, quantityInStock, stepSale, listAtributes) values " &_
					    "('"&userID&"', "&storeID&", "&storeRS("productID")&", '"&checkHTMLString(productName)&"', '"&checkHTMLString(productCode)&"', "&productWeight&", '"&checkHTMLString(productMeasure)&"', "&retailPriceInCart&", "&totalPriceInCart&", "&quantityInput&", "&quantityInStock&", "&stepSaleFromPrice&", '"&listAtributes&"')"
			storeConn.execute sqlString
		else
			sqlString = "update storeCustomersCart set productName='"&checkHTMLString(productName)&"', quantity = "&quantityInput&", retailPriceInCart = "&retailPriceInCart&", totalPriceInCart = "&totalPriceInCart&", stepSale = "&stepSaleFromPrice&" where customerCartID = "&storeTemp("customerCartID")&" and storeID = "&storeID
			storeConn.execute sqlString
		end if
		storeTemp.close
		set storeTemp = nothing
		storeRS.close
		set storeRS = nothing
		setlocale(storeLocaleID)
		set storeConn = nothing
		response.redirect "../viewCart.asp?"&urlString&"viewID=48"
		
	'--------------------------------------------------------------------------------------------
	case "viewCart"
	
		dim operation, customerCartID, i
		dim quantityArray 
	
		operation = trim(request("operation"))
		if operation = "delete" then
			'---------remove the product from cart------------
			customerCartID = trim(request("customerCartID"))
			if not testUrl(customerCartID, errMessage) then
				session("errorMessage") = errMessage
				set storeRS = nothing
				set storeConn = nothing
				response.redirect "../error.asp?viewID=7"
			end if
			sqlString = "delete from storeCustomersCart where customerCartID="&customerCartID&" and storeID="&storeID
			storeConn.execute sqlString
			set storeConn = nothing
			response.redirect "../viewCart.asp?"&urlString&"viewID=48"
		end if
		
		quantityArray = split(trim(request("quantityList")),";")
		sqlString = "select customerCartID, productID, productName, quantityInStock, listAtributes from storeCustomersCart where storeID="&storeID&" and userID = '"&userID&"'"
		set storeRS = Server.CreateObject("ADODB.Recordset")
		storeRS.open sqlString, storeConn, 1, 1
		i=0
		do while not storeRS.eof
			quantityInput = quantityArray(i)
			if not getNumber(quantityInput, quantityInput) then
				storeRS.close
				set storeRS = nothing
				set storeConn = nothing
				session("errorMessage") = Please_enter_a_valid_quantity_CONST
				response.redirect "../error.asp?"&urlString&"viewID=7"
			end if
			quantityInStock = cdbl(storeRS("quantityInStock"))
			productID = storeRS("productID")
			productName = storeRS("productName")
			listAtributes = storeRS("listAtributes")

			setlocale("en-us")
			sqlString = "select priceLineID, price, description, stepSale from storeProductsPrices where storeID="&storeID&" and productID = "&productID&" and lowLimit<="&quantityInput&" and (highLimit>="&quantityInput&" or highLimit=0)"
			set storeRS2 = Server.CreateObject("ADODB.Recordset")
			storeRS2.open sqlString, storeConn, 1, 1
			setlocale(storeLocaleID)
			if storeRS2.eof then
				storeRS2.close
				storeRS.close
				set storeRS2 = nothing
				set storeRS = nothing
				set storeConn = nothing
				session("errorMessage") = This_product_can_t_be_bought_CONST
				response.redirect "../error.asp?"&urlString&"viewID=7"
			end if
			'test if the quantity is OK (if stepSale<>1 then the quantity is multiple of stepSale)			
			stepSaleFromPrice = cdbl(storeRS2("stepSale"))
			theError = quantityInput/stepSaleFromPrice
			if theError - clng(theError)<>0 then
				storeRS2.close
				storeRS.close
				set storeRS2 = nothing
				set storeRS = nothing
				set storeConn = nothing
				session("errorMessage") = The_product_can_be_sold_only_in_preestablished_quantities_CONST
				response.redirect "../error.asp?"&urlString&"viewID=7"
			end if
			
			'----------- calculate the product price who will be saved in the shopping cart --------------------------
			retailPrice = cdbl(storeRS2("price"))
			totalPrice = retailPrice
			call calculateTotalPrice(productID, retailPrice, totalPrice, storeRS2("priceLineID"), listAtributes)
			retailPriceInCart = retailPrice*(quantityInput/stepSaleFromPrice)
			totalPriceInCart = totalPrice*(quantityInput/stepSaleFromPrice)
			priceDescription = storeRS2("description")
			storeRS2.close
			set storeRS2 = nothing
			
			'test if the quantitySubmitted < quantity in stock !
			if quantityInStock <> -1 then
				if quantityInput > quantityInStock then
					storeRS.close
					set storeRS = nothing
					set storeConn = nothing
					session("errorMessage") = Product_out_of_stock_CONST
					response.redirect "../error.asp?"&urlString&"viewID=7"
				end if
			end if
			if priceDescription <> "" then
				sqlString = "select productName from storeProducts where storeID="&storeID&" and productID="&productID
				set storeRS2 = server.CreateObject("ADODB.Recordset")
				storeRS2.open sqlString, storeConn, 1, 1
				productName = storeRS2("productName")&" ("&priceDescription&")"
				storeRS2.close
				set storeRS2 = nothing
			end if

			setlocale("en-us")
			sqlString = "update storeCustomersCart set productName='"&checkHTMLString(productName)&"', quantity = "&quantityInput&",retailPriceInCart = "&retailPriceInCart&",totalPriceInCart = "&totalPriceInCart&",stepSale = "&stepSaleFromPrice&" where customerCartID = "&storeRS("customerCartID")&" and storeID = "&storeID
			storeConn.execute sqlString
			setlocale(storeLocaleID)
			storeRS.movenext
			i=i+1
		loop
		storeRS.close
		set storeRS = nothing
		set storeConn = nothing
		response.redirect "../viewCart.asp?"&urlString&"viewID=48"
end select %>