<%
sub loadFieldDefs()
	redim fieldsInfoHeader(nInfo)
	redim fieldsFilesHeader(nFiles)
	redim fieldsDatabaseHeader(nDatabase)

	redim fieldsInfoData(0)	
	redim fieldsFilesData(0)
	redim fieldsDatabaseData(0)
	
	fieldsInfoHeader(0) = "folder"
	fieldsInfoHeader(1) = "description"
	
	fieldsFilesHeader(0) = "location"
	fieldsFilesHeader(1) = "type"
	fieldsFilesHeader(2) = "name"
	fieldsFilesHeader(3) = "operation"
	fieldsFilesHeader(4) = "encrypt"
	
	fieldsDatabaseHeader(0) = "access"
	fieldsDatabaseHeader(1) = "mssql"
	fieldsDatabaseHeader(2) = "mysql"
	
	fieldsInfoData(0) = ""
	fieldsFilesData(0) = ""
	fieldsDatabaseData(0) = ""

end sub
'------------------------------------------------------------------------
function testHeader(theLine, theHeader)

	dim myHeader, i
	
	myHeader = split(theLine, fieldSep)
	if ubound(myHeader) <> ubound(theHeader) then
		testHeader = false
		exit function
	end if
	for i=0 to ubound(myHeader)
		if lcase(myHeader(i)) <> lcase(theHeader(i)) then
			testHeader = false
			exit function
		end if
	next
	testHeader = true
	
end function
'------------------------------------------------------------------------
function loadInfoFile(theLine, boundInfo)
	dim myHeader
	dim storeRS, sqlString

	myHeader = split(theLine, fieldSep)
	if ubound(myHeader) <> nInfo then
		loadInfoFile = false
		exit function
	end if
	set storeRS = Server.CreateObject("ADODB.Recordset")
	sqlString = "select updateFolder from mallUpdates"
	storeRS.open sqlString, storeConn, 1, 1
	do while not storeRS.eof
		if lcase(storeRS("updateFolder")) = lcase(myHeader(0)) then
			storeRS.close
			set storeRS = nothing
			loadInfoFile = false
			exit function
		end if
		storeRS.movenext
	loop
	storeRS.close
	set storeRS = nothing
	redim preserve fieldsInfoData(boundInfo)
	fieldsInfoData(boundInfo) = theLine
	
	loadInfoFile = true
end function
'------------------------------------------------------------------------
function loadFiles(theLine, boundFiles)
	dim myHeader
	myHeader = split(theLine, fieldSep)
	if ubound(myHeader) <> nFiles then
		loadFiles = false
		exit function
	end if
	'----- test type (file/folder) ----
	if lcase(myHeader(1)) <> "file" and lcase(myHeader(1)) <> "folder" then
		loadFiles = false
		exit function
	end if
	'----- test name of file/folder ----
	if myHeader(2) = "" then
		loadFiles = false
		exit function
	end if
	'----- test operation ----
	if lcase(myHeader(3)) <> "add" and lcase(myHeader(3)) <> "delete" then
		loadFiles = false
		exit function
	end if
	'----- test encrypt ----
	if lcase(myHeader(4)) <> "yes" and lcase(myHeader(4)) <> "no" then
		loadFiles = false
		exit function
	end if
	redim preserve fieldsFilesData(boundFiles)
	fieldsFilesData(boundFiles) = theLine
	loadFiles = true
	
end function
'------------------------------------------------------------------------
function loadDatabase(theLine, boundFiles)
	dim myHeader
	myHeader = split(theLine, fieldSep)
	if ubound(myHeader) <> nDatabase then
		loadDatabase = false
		exit function
	end if
	if myHeader(0) = "" or myHeader(1) = "" or myHeader(2) = "" then
		loadDatabase = false
		exit function
	end if
	redim preserve fieldsDatabaseData(boundFiles)
	fieldsDatabaseData(boundFiles) = theLine
	loadDatabase = true

end function
%>